<template>
  <div>
    <div class="gva-form-box">
      <el-form :model="formData" ref="elFormRef" label-position="right" :rules="rule" label-width="80px">
        <el-form-item label="metamask地址:" prop="address">
          <el-input v-model="formData.address" :clearable="true" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="推特账号:" prop="twiUsername">
          <el-input v-model="formData.twiUsername" :clearable="true" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="活动编号:" prop="twiActId">
          <el-input v-model.number="formData.twiActId" :clearable="true" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="奖励类型:" prop="rewardType">
          <el-select v-model="formData.rewardType" placeholder="请选择" :clearable="true">
            <el-option v-for="(item,key) in twi_reward_typeOptions" :key="key" :label="item.label" :value="item.value" />
          </el-select>
        </el-form-item>
        <el-form-item label="奖励额:" prop="amount">
          <el-input v-model.number="formData.amount" :clearable="true" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="status字段:" prop="status">
          <el-select v-model="formData.status" placeholder="请选择" :clearable="true">
            <el-option v-for="(item,key) in twi_finish_statusOptions" :key="key" :label="item.label" :value="item.value" />
          </el-select>
        </el-form-item>
        <el-form-item>
          <el-button type="primary" @click="save">保存</el-button>
          <el-button type="primary" @click="back">返回</el-button>
        </el-form-item>
      </el-form>
    </div>
  </div>
</template>

<script>
export default {
  name: 'TwiActFinish'
}
</script>

<script setup>
import {
  createTwiActFinish,
  updateTwiActFinish,
  findTwiActFinish
} from '@/api/twiActFinish'

// 自动获取字典
import { getDictFunc } from '@/utils/format'
import { useRoute, useRouter } from "vue-router"
import { ElMessage } from 'element-plus'
import { ref, reactive } from 'vue'
const route = useRoute()
const router = useRouter()

const type = ref('')
const twi_reward_typeOptions = ref([])
const twi_finish_statusOptions = ref([])
const formData = ref({
            address: '',
            twiUsername: '',
            twiActId: 0,
            rewardType: undefined,
            amount: 0,
            status: undefined,
        })
// 验证规则
const rule = reactive({
})

const elFormRef = ref()

// 初始化方法
const init = async () => {
 // 建议通过url传参获取目标数据ID 调用 find方法进行查询数据操作 从而决定本页面是create还是update 以下为id作为url参数示例
    if (route.query.id) {
      const res = await findTwiActFinish({ ID: route.query.id })
      if (res.code === 0) {
        formData.value = res.data.retwiActFinish
        type.value = 'update'
      }
    } else {
      type.value = 'create'
    }
    twi_reward_typeOptions.value = await getDictFunc('twi_reward_type')
    twi_finish_statusOptions.value = await getDictFunc('twi_finish_status')
}

init()
// 保存按钮
const save = async() => {
      elFormRef.value?.validate( async (valid) => {
         if (!valid) return
            let res
           switch (type.value) {
             case 'create':
               res = await createTwiActFinish(formData.value)
               break
             case 'update':
               res = await updateTwiActFinish(formData.value)
               break
             default:
               res = await createTwiActFinish(formData.value)
               break
           }
           if (res.code === 0) {
             ElMessage({
               type: 'success',
               message: '创建/更改成功'
             })
           }
       })
}

// 返回按钮
const back = () => {
    router.go(-1)
}

</script>

<style>
</style>
